/*
 * Intel ACPI Component Architecture
 * AML Disassembler version 20100528
 *
 * Disassembly of SSDT4.dat, Wed Oct 31 09:56:27 2012
 *
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00000577 (1399)
 *     Revision         0x01
 *     Checksum         0x2E
 *     OEM ID           "SgRef"
 *     OEM Table ID     "SgTabl"
 *     OEM Revision     0x00001000 (4096)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20051117 (537202967)
 */
DefinitionBlock ("SSDT4.aml", "SSDT", 1, "SgRef", "SgTabl", 0x00001000)
{
    External (PWOK)
    External (SGMD)
    External (PWEN)
    External (HLRS)
    External (GPRW, IntObj)
    External (\GBAS, MethodObj)    // 1 Arguments
    External (\EECP, MethodObj)    // 1 Arguments
    External (\XBAS, MethodObj)    // 1 Arguments
    External (\_SB_.PCI0.PEG0, DeviceObj)
    External (\_SB_.PCI0.GFX0, DeviceObj)
    External (\_SB_.PCI0.GFX0._DOD, IntObj)
    External (\_SB_.PCI0.GFX0.HDSM, IntObj)
    External (\_SB_.PCI0.PEG0.PEGP, DeviceObj)
    External (\_SB_.PCI0.LPCB.EC__.FCMD)
    External (\_SB_.PCI0.LPCB.EC__.FDAT)
    External (\_SB_.PCI0.LPCB.EC__.DGPU)
    External (\_SB_.PCI0.PEG0.PEGP._ADR)

    Scope (\_SB.PCI0.GFX0)
    {
        Method (_DSM, 4, Serialized)
        {
            If (LEqual (Arg0, Buffer (0x10)
                    {
                        /* 0000 */    0xD3, 0x73, 0xD8, 0x7E, 0xD0, 0xC2, 0x4F, 0x4E, 
                        /* 0008 */    0xA8, 0x54, 0x0F, 0x13, 0x17, 0xB0, 0x1C, 0x2C
                    }))
            {
                Return (One)
            }

            If (CondRefOf (\_SB.PCI0.GFX0.HDSM))
            {
                Return (\_SB.PCI0.GFX0.HDSM)
                Arg0
                Arg1
                Arg2
                Arg3
            }
        }
    }

    Scope (\_SB.PCI0.PEG0)
    {
        OperationRegion (RPCI, PCI_Config, Zero, 0xF0)
        Field (RPCI, DWordAcc, Lock, Preserve)
        {
                    Offset (0xB0), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1
        }

        OperationRegion (RPCX, SystemMemory, \XBAS (0x9000), Field (RPCX, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x8214), 
                        Offset (0x8216), 
                LNKS,   4, 
                        Offset (0x8C20), 
                    ,   4, 
                AFES,   2
            })
        Device (PEGA)
        {
            Name (_ADR, One)
            OperationRegion (ACAP, PCI_Config, \EECP (0x14), Field (ACAP, DWordAcc, NoLock, Preserve)
                {
                            Offset (0x10), 
                    LCT1,   16
                })
            Method (_PRW, 0, NotSerialized)
            {
                Return (GPRW)
                0x09
                0x04
            }
        }
    }

    Scope (\_SB.PCI0.PEG0.PEGP)
    {
        Name (ELCT, Zero)
        Name (HVID, Zero)
        Name (PCLB, Zero)
        Name (PMBB, Zero)
        Name (INTB, Zero)
        OperationRegion (PCIS, SystemMemory, 0xF8100000, 0x0100)
        Field (PCIS, DWordAcc, NoLock, Preserve)
        {
            DVID,   32, 
            VGAR,   2016
        }

        Name (VGAB, Buffer (0xFC)
        {
            0x00
        })
        OperationRegion (GPIO, SystemIO, \GBAS (0x60), Field (GPIO, ByteAcc, Lock, Preserve)
            {
                        Offset (0x0C), 
                LVL0,   32, 
                        Offset (0x38), 
                LVL1,   32, 
                        Offset (0x48), 
                LVL2,   32
            })
        OperationRegion (PCAP, PCI_Config, \EECP (0x14), Field (PCAP, DWordAcc, NoLock, Preserve)
            {
                        Offset (0x10), 
                LCTL,   16
            })
        Method (_INI, 0, NotSerialized)
        {
            Store (Zero, \_SB.PCI0.PEG0.PEGP._ADR)
            Store (VGAR, VGAB)
        }

        Method (SGON, 0, Serialized)
        {
            If (LEqual (\_SB.PCI0.LPCB.EC.DGPU, Zero))
            {
                While (LEqual (\_SB.PCI0.LPCB.EC.DGPU, Zero))
                {
                    Store (One, \_SB.PCI0.LPCB.EC.FDAT)
                    Store (0xBF, \_SB.PCI0.LPCB.EC.FCMD)
                }

                SGPO (HLRS, One)
                SGPO (PWEN, One)
                Sleep (0x012C)
                SGPO (HLRS, Zero)
                Sleep (0x64)
            }

            Store (Zero, LNKD)
            While (LLess (LNKS, 0x07))
            {
                Sleep (One)
            }

            Store (VGAB, VGAR)
            Or (And (ELCT, 0x43), And (LCTL, 0xFFBC), LCTL)
            Or (And (ELCT, 0x43), And (\_SB.PCI0.PEG0.PEGA.LCT1, 0xFFBC), \_SB.PCI0.PEG0.PEGA.LCT1)
            Return (One)
        }

        Method (SGOF, 0, Serialized)
        {
            Store (VGAR, VGAB)
            Store (LCTL, ELCT)
            Store (One, LNKD)
            While (LNotEqual (LNKS, Zero))
            {
                Sleep (One)
            }

            SGPO (HLRS, One)
            SGPO (PWEN, Zero)
            While (LEqual (\_SB.PCI0.LPCB.EC.DGPU, One))
            {
                Store (Zero, \_SB.PCI0.LPCB.EC.FDAT)
                Store (0xBF, \_SB.PCI0.LPCB.EC.FCMD)
            }

            Sleep (0x012C)
            Return (Zero)
        }

        Method (SGST, 0, Serialized)
        {
            If (And (SGMD, 0x0F))
            {
                If (LEqual (SGPI (PWOK), One))
                {
                    Return (0x0F)
                }

                Return (Zero)
            }

            If (LNotEqual (DVID, Ones))
            {
                Return (0x0F)
            }

            Return (Zero)
        }

        Method (_DOD, 0, NotSerialized)
        {
            Return (\_SB.PCI0.GFX0._DOD)
        }

        Method (SGPI, 1, Serialized)
        {
            ShiftRight (Arg0, 0x07, Local1)
            And (Arg0, 0x7F, Arg0)
            If (LLess (Arg0, 0x20))
            {
                Store (\_SB.PCI0.PEG0.PEGP.LVL0, Local0)
                ShiftRight (Local0, Arg0, Local0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    Store (\_SB.PCI0.PEG0.PEGP.LVL1, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x20), Local0)
                }
                Else
                {
                    Store (\_SB.PCI0.PEG0.PEGP.LVL2, Local0)
                    ShiftRight (Local0, Subtract (Arg0, 0x40), Local0)
                }
            }

            If (LEqual (Local1, Zero))
            {
                Not (Local0, Local0)
            }

            Return (And (Local0, One))
        }

        Method (SGPO, 2, Serialized)
        {
            ShiftRight (Arg0, 0x07, Local3)
            And (Arg0, 0x7F, Arg0)
            If (LEqual (Local3, Zero))
            {
                Not (Arg1, Local3)
                And (Local3, One, Local3)
            }
            Else
            {
                And (Arg1, One, Local3)
            }

            If (LLess (Arg0, 0x20))
            {
                ShiftLeft (Local3, Arg0, Local0)
                ShiftLeft (One, Arg0, Local1)
                And (\_SB.PCI0.PEG0.PEGP.LVL0, Not (Local1), Local2)
                Or (Local2, Local0, \_SB.PCI0.PEG0.PEGP.LVL0)
            }
            Else
            {
                If (LLess (Arg0, 0x40))
                {
                    ShiftLeft (Local3, Subtract (Arg0, 0x20), Local0)
                    ShiftLeft (One, Subtract (Arg0, 0x20), Local1)
                    And (\_SB.PCI0.PEG0.PEGP.LVL1, Not (Local1), Local2)
                    Or (Local2, Local0, \_SB.PCI0.PEG0.PEGP.LVL1)
                }
                Else
                {
                    If (LLess (Arg0, 0x7F))
                    {
                        ShiftLeft (Local3, Subtract (Arg0, 0x40), Local0)
                        ShiftLeft (One, Subtract (Arg0, 0x40), Local1)
                        And (\_SB.PCI0.PEG0.PEGP.LVL2, Not (Local1), Local2)
                        Or (Local2, Local0, \_SB.PCI0.PEG0.PEGP.LVL2)
                    }
                }
            }

            Return (One)
        }
    }
}

